
math.randomseed(os.time())

local dm = {}
dm.version = 0.30
dm.zone = {} --zone  dminer
dm.desszone = {} -- tableau des canevas
dm.canvas = Canvas.new()
dmImage = Image.load("sprites.png",VRAM)
dm.ImTitre = Image.load("Titre.gif", VRAM)
dm.ImInterf = Image.load("interf.gif", VRAM)
dm.tabColor = {}
dm.tabColor[1] = Color.new(0,0,31)
dm.tabColor[2] = Color.new(5,11,27)
dm.tabColor[3] = Color.new(5,17,27)
dm.tabColor[4] = Color.new(5,27,26)
dm.tabColor[5] = Color.new(5,27,19)
dm.tabColor[6] = Color.new(5,27,14)
dm.tabColor[7] = Color.new(5,27,5)
dm.tabColor[8] = Color.new(0,31,0)
dm.state = 0 -- 0=start 1=Lose 2=win 3=menu 4=quit
dm.timer = Timer.new()
dm.black = Color.new(0,0,0)
dm.maxX = 5
dm.maxY = 5
dm.nbBM = 5
dm.font28 = Font.load("Stencil28.oft")
dm.font36 = Font.load("Stencil36.oft")

dm.createZone = function(nbx, nby, nbm)
	dm.maxX = nbx
	dm.maxY = nby
	dm.nbBM = nbm
	dm.nbB = nbm
	dm.nbC = nbx * nby
	local i, j, x, y
	-- Cration tableau vide avec 2 lignes et 2 collones supplmentaires
	for i = 0, nbx+1 do
		dm.zone[i] = {}
		dm.desszone[i] = {}
		for j = 0, nby+1 do
			dm.zone[i][j] = 0
			dm.desszone[i][j] = {}
		end
	end
	for i = 1, nbm do
		repeat
			x = math.random(1, nbx)
			y = math.random(1, nby)
		until(dm.zone[x][y] == 0)
		dm.zone[x][y] = 9
	end
	for i=1, dm.maxX do
		x = (i-1)*15
		for j=1, dm.maxY do
			y = (j-1)*15
			r = dm.zone[i][j]
			dm.desszone[i][j][1] =  Canvas.newImage(x,y,dmImage,15,0,15,15)
			Canvas.add(dm.canvas, dm.desszone[i][j][1])
		end
	end
end

dm.countBomb = function(x, y)
	local nb =0
	local i, j
	if(x>0 and x<dm.maxX+1) then
		if(y>0 and y<dm.maxY+1) then
			for i = x-1, x+1 do
				for j = y-1, y+1 do
					if(dm.zone[i][j] == 9 or dm.zone[i][j] == 29) then nb = nb+1 end
				end
			end
			return nb
		end
	end
	return 10
end

dm.decouvre = function(x, y)
	local i, j, r
	dm.zone[x][y] = 10
	Canvas.setAttr(dm.desszone[x][y][1], ATTR_X2, 30)
	dm.nbC = dm.nbC -1
	for i=x-1, x+1 do
		for j=y-1, y+1 do
			if(dm.zone[i][j] < 10) then
				r = dm.countBomb(i,j)
				if(r == 0) then dm.decouvre(i, j) end
				dm.zone[i][j] = 10+r
				if(r>0 and r<10) then
					Canvas.setAttr(dm.desszone[i][j][1], ATTR_X2, 30)
					Canvas.add(dm.canvas, Canvas.newText(((i-1)*15)+4,((j-1)*15)+4, dm.zone[i][j]-10, dm.tabColor[r]))
					dm.nbC = dm.nbC -1
				end
			end
		end
	end
end

dm.creuse = function(x, y)
	local r = dm.countBomb(x, y)
	if(r == 0) then dm.decouvre(x, y)
	elseif(dm.zone[x][y] == 9) then dm.boum(x, y)
	else
		dm.zone[x][y] = 10+r
		Canvas.setAttr(dm.desszone[x][y][1], ATTR_X2, 30)
		Canvas.add(dm.canvas, Canvas.newText(((x-1)*15)+4,((y-1)*15)+4, dm.zone[x][y]-10, dm.tabColor[r]))
		dm.nbC = dm.nbC -1
	end
end

dm.boum = function(x, y)
	local i,j
	for i=1, dm.maxX do
		for j=1, dm.maxY do
			if(dm.zone[i][j] == 9) then
				Canvas.setAttr(dm.desszone[i][j][1], ATTR_X2, 30)
				Canvas.add(dm.canvas, Canvas.newImage((i-1)*15,(j-1)*15,dmImage,75,0,15,15))
			elseif(dm.zone[i][j] > 19 and dm.zone[i][j] < 29) then
				Canvas.add(dm.canvas, Canvas.newImage((i-1)*15,(j-1)*15,dmImage,90,0,15,15))
			end
		end
	end
	dm.state = 1
end

dm.flag = function(x, y)
	if(dm.zone[x][y] > 19) then 
		Canvas.setAttr(dm.desszone[x][y][2], ATTR_X2, 0)
		dm.zone[x][y] = dm.zone[x][y] - 20
		dm.nbB = dm.nbB +1
		dm.nbC = dm.nbC +1
	elseif(dm.zone[x][y] < 10) then
		if(dm.desszone[x][y][2] == nil) then
			dm.desszone[x][y][2] =  Canvas.newImage((x-1)*15,(y-1)*15,dmImage,60,0,15,15)
			Canvas.add(dm.canvas, dm.desszone[x][y][2])
		else Canvas.setAttr(dm.desszone[x][y][2], ATTR_X2, 60) end
		dm.zone[x][y] = dm.zone[x][y] + 20
		dm.nbB = dm.nbB -1
		dm.nbC = dm.nbC -1
	end
end

dm.showTime = function()
	local heure, min, sec, rest
	rest = dm.timer:time()
	min = math.floor(rest/60000)
	rest = rest % 60000
	sec = math.floor(rest/1000)
	screen.printFont(SCREEN_UP, 48,13, min..":"..sec, dm.black, dm.font28)
end

dm.menu = function()
	--Canvas du menu principal
	local canvasMenu = Canvas.new()
	Canvas.add(canvasMenu, Canvas.newImage(0,0, dmImage, 0,15, 105, 20))
	Canvas.add(canvasMenu, Canvas.newText(28,7,"* MENU *",dm.black))
	Canvas.add(canvasMenu, Canvas.newImage(9,30, dmImage, 0,35, 87, 20))
	Canvas.add(canvasMenu, Canvas.newText(34,37,"Facile",dm.black))
	Canvas.add(canvasMenu, Canvas.newImage(9,55, dmImage, 0,35, 87, 20))
	Canvas.add(canvasMenu, Canvas.newText(37,62,"Moyen",dm.black))
	Canvas.add(canvasMenu, Canvas.newImage(9,80, dmImage, 0,35, 87, 20))
	Canvas.add(canvasMenu, Canvas.newText(25,87,"Difficile",dm.black))
	Canvas.add(canvasMenu, Canvas.newImage(9,105, dmImage, 0,35, 87, 20))
	Canvas.add(canvasMenu, Canvas.newText(16,112,"Personnalis",dm.black))
	Canvas.add(canvasMenu, Canvas.newImage(9,145, dmImage, 0,35, 87, 20))
	Canvas.add(canvasMenu, Canvas.newText(31,152,"Quitter",dm.black))
	local choix = 0
	while(choix == 0) do
		Controls.read()
		screen.blit(SCREEN_UP,0,0,dm.ImTitre)
		screen.print(SCREEN_UP,170,180,"Version: "..dm.version, dm.black)
		screen.drawFillRect(SCREEN_DOWN,0,0,256,192,Color.new(25,25,25))
		Canvas.draw(SCREEN_DOWN, canvasMenu, 76, 10)
		if(Stylus.newPress) then
			if(Stylus.X > 85 and Stylus.X < 172) then
				if(Stylus.Y > 40 and Stylus.Y < 60) then choix = 1
				elseif(Stylus.Y > 65 and Stylus.Y < 85) then choix = 2
				elseif(Stylus.Y > 90 and Stylus.Y < 110) then choix = 3
				elseif(Stylus.Y > 115 and Stylus.Y < 135) then choix = dm.perso()
				elseif(Stylus.Y > 155 and Stylus.Y < 175) then choix = 5 end
			end
		end
		render()
	end
	if(choix == 1) then dm.createZone(6,6,5)
	elseif(choix == 2) then dm.createZone(11,10,20)
	elseif(choix == 3) then dm.createZone(17,12,40)
	elseif(choix == 4) then dm.createZone(dm.maxX, dm.maxY, dm.nbBM)
	elseif(choix == 5) then dm.state = 4
	end
	if(choix < 5) then
		dm.state = 0
		dm.depx = 128-math.floor((dm.maxX*15)/2)
		dm.depy = 96-math.floor((dm.maxY*15)/2)
	end
	Canvas.destroy(canvasMenu)
--	Debug.clear()
--	Debug.print("Menu:"..choix.."  Etat:"..dm.state)
end

dm.affichageFin = function()
	--Canvas du menu de fin de partie
	local canvasFin = Canvas.new()
	Canvas.add(canvasFin, Canvas.newImage(0,0, dmImage, 0,15, 105, 20))
	local txtFin = Canvas.newText(24,7,"Texte",dm.black)
	Canvas.add(canvasFin, txtFin)
	Canvas.add(canvasFin, Canvas.newImage(9,30, dmImage, 0,35, 87, 20))
	Canvas.add(canvasFin, Canvas.newText(31,37,"Rejouer",dm.black))
	Canvas.add(canvasFin, Canvas.newImage(9,55, dmImage, 0,35, 87, 20))
	Canvas.add(canvasFin, Canvas.newText(39,62,"Menu",dm.black))
	local choix = 0
	dm.timer:stop()
	local rest = dm.timer:time()
	local min = math.floor(rest/60000)
	rest = rest % 60000
	local sec = math.floor(rest/1000)
	local txt = "GAGNE"
	if(dm.state == 1) then txt = "PERDU" end
	txt = txt.." en:"..min.."m"..sec.."s"
	Canvas.setAttr(txtFin, ATTR_TEXT, txt)
	Canvas.setAttr(txtFin, ATTR_X1, 52-math.floor((string.len(txt)*6)/2))
	while(choix == 0) do
		Controls.read()
		screen.drawFillRect(SCREEN_UP,0,0,256,192,Color.new(25,25,25))
		Canvas.draw(SCREEN_UP, dm.canvas, dm.depx, dm.depy)
		screen.drawFillRect(SCREEN_DOWN,0,0,256,192,Color.new(25,25,25))
		Canvas.draw(SCREEN_DOWN, canvasFin, 76, 61)
		if(Stylus.newPress) then
			if(Stylus.X > 85 and Stylus.X < 172) then
				if(Stylus.Y > 91 and Stylus.Y < 111) then choix = 1
				elseif(Stylus.Y > 116 and Stylus.Y < 136) then choix = 2 end
			end
		end
		render()
	end
	dm.timer:reset()
	Canvas.destroy(dm.canvas)
	Canvas.destroy(canvasFin)
	dm.canvas = Canvas.new()
	dm.state = 3
	dm.nbC = 1
	if(choix == 1) then
		dm.state = 0
		dm.createZone(dm.maxX, dm.maxY, dm.nbBM)
	end
end

dm.affichageJeu = function()
	screen.blit(SCREEN_UP, 0, 0, dm.ImInterf)
	screen.drawFillRect(SCREEN_DOWN,0,0,256,192,Color.new(25,25,25))
	Canvas.draw(SCREEN_DOWN, dm.canvas, dm.depx, dm.depy)
	screen.printFont(SCREEN_UP, 60, 145, dm.nbB, dm.black, dm.font36)
	screen.print(SCREEN_UP, 116, 99, "Maintenir A ou gauche", dm.black)
	screen.print(SCREEN_UP, 116, 111, "pour poser/supprimer", dm.black)
	screen.print(SCREEN_UP, 116, 123, "un drapeau.", dm.black)
	screen.print(SCREEN_UP, 116, 135, "Pause = Start", dm.black)
	dm.showTime()
	screen.print(SCREEN_UP, 185, 147, "FPS:"..NB_FPS, dm.black)
end

dm.pause = function()
	local canvasPause = Canvas.new()
	Canvas.add(canvasPause, Canvas.newImage(0,0, dmImage, 0,15, 105, 20))
	Canvas.add(canvasPause, Canvas.newText(37,7,"Pause",dm.black))
	Canvas.add(canvasPause, Canvas.newImage(9,30, dmImage, 0,35, 87, 20))
	Canvas.add(canvasPause, Canvas.newText(25,37,"Reprendre",dm.black))
	Canvas.add(canvasPause, Canvas.newImage(9,55, dmImage, 0,35, 87, 20))
	Canvas.add(canvasPause, Canvas.newText(39,62,"Menu",dm.black))
	local choix = 0
	dm.timer:stop()
	while(choix == 0) do
		Controls.read()
		dm.affichageJeu()
		screen.drawFillRect(SCREEN_DOWN,0,0,256,192,Color.new(25,25,25))
		Canvas.draw(SCREEN_DOWN, canvasPause, 76, 61)
		if(Stylus.newPress) then
			if(Stylus.X > 85 and Stylus.X < 172) then
				if(Stylus.Y > 91 and Stylus.Y < 111) then choix = 1
				elseif(Stylus.Y > 116 and Stylus.Y < 136) then choix = 2 end
			end
		end
		render()
	end
	Canvas.destroy(canvasPause)
	if(choix == 2) then
		dm.timer:reset()
		Canvas.destroy(dm.canvas)
		dm.canvas = Canvas.new()
		dm.state = 3
		dm.nbC = 1
	else
		dm.timer:start()
	end
	Controls.read()
end

dm.perso = function()
	local canvasPerso = Canvas.new()
	Canvas.add(canvasPerso, Canvas.newImage(27,0, dmImage, 0, 15, 105, 20))
	Canvas.add(canvasPerso, Canvas.newText(43,7,"Prsonnalis",dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,42,127,42,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,43,127,43,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,44,127,44,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,79,127,79,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,80,127,80,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,81,127,81,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,116,127,116,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,117,127,117,dm.black))
	Canvas.add(canvasPerso, Canvas.newLine(27,118,127,118,dm.black))
	local curs = {}
	local tcurs = {}
	curs[1] = Canvas.newImage(27,35, dmImage, 91,35, 8, 15)
	curs[2] = Canvas.newImage(27,72, dmImage, 91,35, 8, 15)
	curs[3] = Canvas.newImage(27,109, dmImage, 91,35, 8, 15)
	tcurs[1] = Canvas.newText(27,27,"1",dm.black)
	tcurs[2] = Canvas.newText(27,64,"1",dm.black)
	tcurs[3] = Canvas.newText(27,101,"1",dm.black)
	Canvas.add(canvasPerso, curs[1])
	Canvas.add(canvasPerso, curs[3])
	Canvas.add(canvasPerso, curs[2])
	Canvas.add(canvasPerso, tcurs[1])
	Canvas.add(canvasPerso, tcurs[3])
	Canvas.add(canvasPerso, tcurs[2])
	Canvas.add(canvasPerso, Canvas.newText(0,39,"X: 1",dm.black))
	Canvas.add(canvasPerso, Canvas.newText(0,76,"Y: 1",dm.black))
	Canvas.add(canvasPerso, Canvas.newText(130,39,"17",dm.black))
	Canvas.add(canvasPerso, Canvas.newText(130,76,"12",dm.black))
	Canvas.add(canvasPerso, Canvas.newText(0,113,"B: 1",dm.black))
	local maxBb = Canvas.newText(130,113,math.floor((dm.maxX*dm.maxY)/2),dm.black)
	Canvas.add(canvasPerso, maxBb)
	Canvas.setAttr(curs[1],ATTR_X1,math.floor((dm.maxX*100)/17)+27)
	Canvas.setAttr(curs[2],ATTR_X1,math.floor((dm.maxY*100)/12)+27)
	Canvas.setAttr(curs[3],ATTR_X1,math.floor((dm.nbBM*100)/math.floor((dm.maxX*dm.maxY)/2))+27)
	Canvas.setAttr(tcurs[1],ATTR_TEXT,dm.maxX)
	Canvas.setAttr(tcurs[2],ATTR_TEXT,dm.maxY)
	Canvas.setAttr(tcurs[3],ATTR_TEXT,dm.nbBM)
	Canvas.setAttr(tcurs[1],ATTR_X1,math.floor((dm.maxX*100)/17)+27)
	Canvas.setAttr(tcurs[2],ATTR_X1,math.floor((dm.maxY*100)/12)+27)
	Canvas.setAttr(tcurs[3],ATTR_X1,math.floor((dm.nbBM*100)/math.floor((dm.maxX*dm.maxY)/2))+27)
	Canvas.add(canvasPerso, Canvas.newImage(-20,133, dmImage, 0,35, 87, 20))
	Canvas.add(canvasPerso, Canvas.newText(2,140,"Valider",dm.black))
	Canvas.add(canvasPerso, Canvas.newImage(80,133, dmImage, 0,35, 87, 20))
	Canvas.add(canvasPerso, Canvas.newText(102,140,"Annuler",dm.black))
	local choix = 0
	local sel = 0
	local maxb = 0
	local chgt = false
	while(choix == 0) do
		Controls.read()
		screen.blit(SCREEN_UP,0,0,dm.ImTitre)
		screen.drawFillRect(SCREEN_DOWN,0,0,256,192,Color.new(25,25,25))
		Canvas.draw(SCREEN_DOWN, canvasPerso, 46, 19)
		if(Stylus.newPress) then
			if(Stylus.X > 73 and Stylus.X < 173) then
				if(Stylus.Y > 54 and Stylus.Y < 69) then sel = 1
				elseif(Stylus.Y > 91 and Stylus.Y < 106) then sel = 2
				elseif(Stylus.Y > 128 and Stylus.Y < 143) then sel = 3
				else sel = 0 end
			else sel = 0 end
			if(Stylus.Y > 152 and Stylus.Y < 172) then
				if(Stylus.X > 26  and Stylus.X < 113) then choix = 4
				elseif(Stylus.X >148  and Stylus.X < 235) then choix = 1 end
			end
			chgt = true
		end
		if(Stylus.held) then
		Debug.clear()
		Debug.print(Stylus.X)
			if(Stylus.X > 73 and Stylus.X < 173) then chgt = true end
		end
		if(chgt) then
			if(sel == 1) then
				dm.maxX = math.floor(((Stylus.X-73)*17)/100)+1
				Canvas.setAttr(curs[sel], ATTR_X1, math.floor(((dm.maxX-1)*100)/17)+27)
				Canvas.setAttr(tcurs[sel], ATTR_X1, math.floor(((dm.maxX-1)*100)/17)+27)
				Canvas.setAttr(tcurs[sel], ATTR_TEXT, dm.maxX)
			elseif(sel == 2) then
				dm.maxY = math.floor(((Stylus.X-73)*12)/100)+1
				Canvas.setAttr(curs[sel], ATTR_X1, math.floor(((dm.maxY-1)*100)/12)+27)
				Canvas.setAttr(tcurs[sel], ATTR_X1, math.floor(((dm.maxY-1)*100)/12)+27)
				Canvas.setAttr(tcurs[sel], ATTR_TEXT, dm.maxY)
			elseif(sel == 3) then
				dm.nbBM = math.floor(((Stylus.X-73)*math.floor((dm.maxX*dm.maxY)/2))/100)+1
			end
			maxb = math.floor((dm.maxX*dm.maxY)/2)
			if(dm.nbBM > maxb) then dm.nbBM = maxb
			elseif(dm.nbBM == 0 and maxb > 0) then dm.nbBM = 1 end
			Canvas.setAttr(maxBb, ATTR_TEXT, maxb)
			Canvas.setAttr(curs[3],ATTR_X1,math.floor(((dm.nbBM-1)*100)/maxb)+27)
			Canvas.setAttr(tcurs[3],ATTR_X1,math.floor(((dm.nbBM-1)*100)/maxb)+27)
			Canvas.setAttr(tcurs[3],ATTR_TEXT,dm.nbBM)
			chgt = false
		end
		render()
	end
	Canvas.destroy(canvasPerso)
	if(choix == 1) then choix = 0 end
	return choix
end

local quit = false
dm.depx ,dm.depy = 0, 0
local sx, sy, r

dm.menu()

while not quit do
	Controls.read()
	if(dm.state == 0) then dm.timer:start() else dm.timer:stop() end
	if(Keys.newPress.Start) then dm.pause() end
	if(Stylus.newPress) then
		sx = math.floor((Stylus.X - dm.depx)/15) +1
		sy = math.floor((Stylus.Y - dm.depy)/15) +1
		if(sx>0 and sx<dm.maxX+1) then
			if(sy>0 and sy<dm.maxY+1) then
				if(Keys.held.A or Keys.held.Left) then dm.flag(sx, sy)					
				elseif(dm.zone[sx][sy] < 10) then dm.creuse(sx, sy) end
			end
		end
	end
	
	if(dm.nbC == 0) then dm.state = 2 end
	if(dm.state == 0) then dm.affichageJeu()
	elseif(dm.state == 3) then dm.menu()
	elseif(dm.state == 4) then quit = true
	else dm.affichageFin() end
	render()
end
local a = 0
local b = 0
while(a<7) do
	Controls.read()
	if(a==1 and b == 1) then Canvas.destroy(dm.canvas) b = 0 end
	if(a==2 and b == 1) then Image.destroy(dmImage) b = 0 end
	if(a==3 and b == 1) then Image.destroy(dm.ImTitre) b = 0 end
	if(a==4 and b == 1) then Image.destroy(dm.ImInterf) b = 0 end
	if(a==5 and b == 1) then Font.destroy(dm.font28) b = 0 end
	if(a==6 and b == 1) then Font.destroy(dm.font36) b = 0 end
	if(Keys.newPress.A) then a = a+1 b = 1 end
	screen.print(SCREEN_UP, 0, 0,"VRAM : "..ds_system.CurrentVramFree())
	screen.print(SCREEN_UP, 0, 10, "LuaRam : "..math.floor(collectgarbage("count")))
	render()
end
